
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux shell中的I/O重定向相关（转） / iVAN</title>

    <meta name="description" content="Linux shell中的I/O重定向相关（转） 1. 基本概念(这是理解后面的知识的前提,请务必理解)  a. I/O重定向通常与 FD有关,shell的FD通常为10个,即 0-9: b. 常用FD有3个,为0(stdin,标准输入).1(stdout,标准输出).2(stderr,标准错误输出),默认与keyboard.monitor.monitor有关: c. 用 &lt; 来改变读进的数据信道(stdin),使之从指定的档案读进: d. 用 &gt; 来改变送出的数据信道(stdout, stderr),使之输出到指定的档案: e.  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Linux shell中的I/O重定向相关（转）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>1、 基本概念（这是理解后面的知识的前提，请务必理解） </strong></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<pre>a、 I/O重定向通常与 FD有关，shell的FD通常为10个，即 0～9； 

b、 常用FD有3个，为<strong>0（stdin，标准输入）</strong>、<strong>1（stdout，标准输出）</strong>、<strong>2（stderr，标准错误输出）</strong>，默认与keyboard、monitor、monitor有关； 

c、 用 &lt; 来改变读进的数据信道(stdin)，使之从指定的档案读进； 

d、 用 &gt; 来改变送出的数据信道(stdout, stderr)，使之输出到指定的档案； 

e、 0 是 &lt; 的默认值，因此 &lt; 与 0&lt;是一样的；同理，&gt; 与 1&gt; 是一样的； 

f、 在IO重定向 中，stdout 与 stderr 的管道会先准备好，才会从 stdin 读进资料； 

g、 管道“|”(pipe line):上一个命令的 stdout 接到下一个命令的 stdin; 

h、 tee 命令是在不影响原本 I/O 的情况下，将 stdout 复制一份到档案去; 

i、 bash（ksh）执行命令的过程：分析命令－变量求值－命令替代（``和$( )）－重定向－通配符展开－确定路径－执行命令； 

j、 ( ) 将 command group 置于 sub-shell 去执行，也称 nested sub-shell，它有一点非常重要的特性是：继承父shell的Standard input, output, and error plus any other open file descriptors。 

k、 exec 命令：常用来替代当前 shell 并重新启动一个 shell，换句话说，并没有启动子 shell。使用这一命令时任何现有环境都将会被清除。exec 在对文件描述符进行操作的时候，也只有在这时，exec 不会覆盖你当前的 shell 环境。 </pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ181MWU0MDliMTFhYTUxYzE1MDA5MDY5NzQyOWE5NTNlZC5naWY=.jpg"></a></p>
<p> </p>
<p><strong>2、 基本IO</strong> </p>
<table>
<tbody>
<tr>
<td>
<p><code>cmd &gt; file 把 stdout 重定向到 file 文件中； </code></p>
<p> </p>
<p><code>cmd &gt;&gt; file 把 stdout 重定向到 file 文件中(追加)； </code></p>
<p> </p>
<p><code>cmd 1&gt; fiel 把 stdout 重定向到 file 文件中； </code></p>
<p> </p>
<p><code>cmd &gt; file 2&gt;&amp;1 把 stdout 和 stderr 一起重定向到 file 文件中； </code></p>
<p> </p>
<p><code>cmd 2&gt; file 把 stderr 重定向到 file 文件中； </code></p>
<p> </p>
<p><code>cmd 2&gt;&gt; file 把 stderr 重定向到 file 文件中(追加)； </code></p>
<p> </p>
<p><code>cmd &gt;&gt; file 2&gt;&amp;1 把 stderr 和 stderr 一起重定向到 file 文件中(追加)； </code></p>
<p> </p>
<p><code>cmd &lt; file &gt;file2 cmd 命令以 file 文件作为 stdin，以 file2 文件作为 stdout； </code></p>
<p> </p>
<p><code>cat &lt;&gt;file 以读写的方式打开 file； </code></p>
<p> </p>
<p><code>cmd &lt; file cmd 命令以 file 文件作为 stdin； </code></p>
<p> </p>
<p><code>cmd &lt;&lt; delimiter Here document，从 stdin 中读入，直至遇到 delimiter 分界符。 </code></p>
</td>
</tr>
</tbody>
</table>
<p><strong>3、 进阶IO</strong> </p>
<table>
<tbody>
<tr>
<td>
<p><code>&gt;&amp;n 使用系统调用 dup (2) 复制文件描述符 n 并把结果用作标准输出； </code></p>
<p> </p>
<p><code>&lt;&amp;n 标准输入复制自文件描述符 n； </code></p>
<p> </p>
<p><code>&lt;&amp;- 关闭标准输入（键盘）； </code></p>
<p> </p>
<p><code>&gt;&amp;- 关闭标准输出； </code></p>
<p> </p>
<p><code>n&lt;&amp;- 表示将 n 号输入关闭； </code></p>
<p> </p>
<p><code>n&gt;&amp;- 表示将 n 号输出关闭； </code></p>
<p> </p>
<p><code>上述所有形式都可以前导一个数字，此时建立的文件描述符由这个数字指定而不是缺省的 0 或 1。如： </code></p>
<p> </p>
<p><code>... 2&gt;file 运行一个命令并把错误输出(文件描述符 2)定向到 file。 </code></p>
<p> </p>
<p><code>... 2&gt;&amp;1 运行一个命令并把它的标准输出和输出合并。(严格的说是通过复制文件描述符 1 来建立文件描述符 2 ，但效果通常是合并了两个流。) </code></p>
<p> </p>
<p><code>我 们对 2&gt;&amp;1详细说明一下 ：2&gt;&amp;1 也就是 FD2＝FD1 ，这里并不是说FD2 的值 等于FD1的值，因为 &gt; 是改变送出的数据信道，也就是说把 FD2 的 “数据输出通道” 改为 FD1 的 “数据输出通道”。如果仅仅这样，这个改变好像没有什么作用，因为 FD2 的默认输出和 FD1的默认输出本来都是 monitor，一样的！ 但是，当 FD1 是其他文件，甚至是其他 FD 时，这个就具有特殊的用途了。请大家务必理解这一点。 </code></p>
<p> </p>
<p><code>exec</code> <code>0exec 1&gt;outfilename # 打开文件outfilename作为stdout。 </code></p>
<p> </p>
<p><code>exec</code> <code>2&gt;errfilename # 打开文件 errfilename作为 stderr。 </code></p>
<p> </p>
<p><code>exec</code> <code>0&lt;&amp;- # 关闭 FD0。 </code></p>
<p> </p>
<p><code>exec</code> <code>1&gt;&amp;- # 关闭 FD1。 </code></p>
<p> </p>
<p><code>exec</code> <code>5&gt;&amp;- # 关闭 FD5。 </code></p>
</td>
</tr>
</tbody>
</table>
<p> </p>
<p>问： 如果关闭了 FD0、FD1、FD2，其后果是什么？ 恢复 FD0、FD1、FD2与 关闭FD0、FD1、FD2 有什么区别？代码分别是什么？ 打开了FD3～FD9，我们用完之后，你觉得是将他们关闭还是恢复？ </p>
<p>下面是提示（例子来源于CU一帖子，忘记出处，来日再补上）： </p>
<pre>1 exec 6&gt;&amp;2 2&gt;ver 2 command &gt;&gt;dev/null &amp; 3 exec 2&gt;&amp;6 # 恢复 FD2</pre>
<p><strong>4、 简单举例</strong> </p>
<p>a、stdout和stderr都通过管道送给egrep了： </p>
<pre>1 (ls you no 2&gt;&amp;1;ls yes 2&gt;&amp;1) 2&gt;&amp;1|egrep \* &gt;file 2 (ls you no 2&gt;&amp;1;ls yes 2&gt;&amp;1)|egrep \* &gt;file 3 (ls you no;ls yes) 2&gt;&amp;1|egrep \* &gt;file</pre>
<p>这个例子要注意的就是： </p>
<p>理 解 命令执行顺序 和 管道“|”：在命令执行前，先要进行重定向的处理，并将把 nested sub-shell 的stdout 接到 egrep 命令的 stdin。 <br />nested sub-shell ，在 ( ) 中的两个命令加上（），可以看作一个命令。其 FD1 已经连接到“|”往egrep送了，当遇到 2&gt;&amp;1时，也就是FD2＝FD1，即FD2同FD1一样，往管道 “|”那边送。 </p>
<p>b、 没有任何东西通过管道送给egrep，全部送往monitor。 (ls you no 2&gt;&amp;1;ls yes 2&gt;&amp;1) &gt;&amp;2|egrep \* &gt;file。虽然在（）里面将 FD2转往FD1，但在（）外，遇到 &gt;&amp;2 ，结果所有的都送到monitor。 请理解： </p>
<pre>1 (ls you no 2&gt;&amp;1) 1&gt;&amp;2|egrep \* &gt;file ## 送到 monitor 2 ls you no 2&gt;&amp;1 1&gt;&amp;2|egrep \* &gt;file ## 送给 管道 “|” 3 ls you no 1&gt;&amp;2 2&gt;&amp;1|egrep \* &gt;file ## 送到 monitor</pre>
<p> </p>
<pre>exec 4&gt;&amp;1;(ls you no 2&gt;&amp;1 1&gt;&amp;4 4&gt;&amp;-;ls yes 2&gt;&amp;1 1&gt;&amp;4 4&gt;&amp;-)|egrep \* &gt;file;exec 4&gt;&amp;- 或者 exec 4&gt;&amp;1;(ls you no;ls yes) 2&gt;&amp;1 1&gt;&amp;4 4&gt;&amp;-|egrep \* &gt;file;exec 4&gt;&amp;-</pre>
<p><strong>5、 中阶例子</strong> <br />条件： stderr通过管道送给egrep，正确消息仍然送给monitor（不变） <br />如果加两个条件： </p>
<p>（1）要求cmd1和cmd2并行运行； </p>
<p>（2）将cmd1的返回值赋给变量 ss。 </p>
<p>则为： </p>
<pre>exec 3&gt;&amp;1;exec 4&gt;&amp;1 ss=$(((ls you no 2&gt;&amp;1 1&gt;&amp;3 3&gt;&amp;-;echo $? &gt;&amp;4)|egrep \* &gt;file) 4&gt;&amp;1) exec 3&gt;&amp;-;exec 4&gt;&amp;-</pre>
<p> 说明： </p>
<p>exec 3&gt;&amp;1;4&gt;&amp;1 建立FD3，是用来将下面ls那条语句（子shell）中的FD1 恢复到正常FD1，即输出到monitor，你可以把FD3看作最初始的FD1的硬盘备份（即输出到monitor）；建立FD4，到时用作保存ls的返 回值（echo $?），你可以将FD4看作你考试时用于存放计算“echo $?”的草稿纸； </p>
<p>(ls you no 2&gt;&amp;1 1&gt;&amp;3 3&gt;&amp;-;echo $? &gt;&amp;4) 大家还记得前面说的子shell和管道吧。这条命令首先会继承FD0、FD1、FD2、FD3、FD4，它位于管道前，所以在运行命令前会先把子 shell自己的FD1和管道“|”相连。但是我们的条件是stderr通过管道送往egrep，stdout仍然输出到monitor。 于是通过2&gt;&amp;1，先把 子shell的FD1 的管道“送给”FD2，于是子shell中的stderr送往管道“|”；再通过 1&gt;&amp;3，把以前的“硬盘备份”恢复给子shell的FD1，于是子shell中的FD1变成送到monitor了。再通过 3&gt;&amp;- ，将3关闭；接着运行echo $? ，本来其输出值应该送往管道的，通过 &gt;&amp;4 ，将 输出 送往 “草稿纸”FD4，留以备用。 </p>
<p>((ls you no 2&gt;&amp;1 1&gt;&amp;3 3&gt;&amp;-;echo $? &gt;&amp;4)|egrep \* &gt;file) 于是，stderr 通过管道送给 egrep ，stdout 送给monitor，但是，还有 FD4，它送到哪去了？ $(((ls you no 2&gt;&amp;1 1&gt;&amp;3 3&gt;&amp;-;echo $? &gt;&amp;4)|egrep \* &gt;file) 4&gt;&amp;1)最后的 4&gt;&amp;1 ，就是把FD4 重定向到 FD1。但由于其输出在 $( )中，其值就赋给变量ss了。最后一行关闭 FD3、FD4。 <br /><em><br /></em><em><strong>6、 高阶例子</strong> </em></p>
<p><em>命令 cmd1, cmd2, cmd3, cmd4. 如何利用单向管道完成下列功能： </em></p>
<p><em>1. 所有命令并行执行。 </em></p>
<p><em>2. cmd1 和 cmd2 不需要 stdin。 </em></p>
<p><em>3. cmd1 和 cmd2 的 stdout 定向到 cmd3 的 stdin。 </em></p>
<p><em>4. cmd1 和 cmd2 的 stderr 定向到 cmd4 的 stdin。 </em></p>
<p><em>5. cmd3 的 stdout 定向到文件 a, stderr 定向到屏幕。 </em></p>
<p><em>6. cmd4 的 stdout 定向到文件 b, stderr 定向到屏幕。 </em></p>
<p><em>7. cmd1 的返回码赋给变量 s。 </em></p>
<p><em>8. 不能利用临时文件。 </em></p>
<p><em>解决方法： </em></p>
<pre>exec 3&gt;&amp;1; exec 4&gt;&amp;1 s=$(((((cmd1 1&gt;&amp;3 ; echo $? &gt;&amp;4 )| cmd2 ) 3&gt;&amp;1 | cmd3 &gt;a 2&gt;&amp;3 ) 2&gt;&amp;1 | cmd4 &gt;b ) 4&gt;&amp;1) exec 3&gt;&amp;-; exec 4&gt;&amp;-</pre>
<p> </p>
<p>这 个我一步步解释（好复杂，自己感觉看明白了，过一会再看，大脑仍然有几分钟空白～～～，没想到我也能看明白。exec 3&gt;&amp;1; exec 4&gt;&amp;1 前面的例子都有说明了，就是建立FD3 ，给cmd1恢复其FD1用和给cmd3 恢复其FD2用，建立FD4，保存“echo $?”输出值的“草稿纸”。 </p>
<p>第一对 括号：(cmd1 1&gt;&amp;3 ; echo $? &gt;&amp;4 ) 和其后（第一个）管道。在第一个括号（子shell）中，其FD1已经连到 管道中了，所以用 FD3 将 FD1恢复正常，不让他往管道跑；这里的cmd1没有stdin，接着将 cmd1 运行的返回码 保存到 FD4 中。 </p>
<p>第 二对括号：((cmd1 1&gt;&amp;3 ; echo $? &gt;&amp;4 )| cmd2 ) 3&gt;&amp;1 和其后（第二个）管道。前面的 FD1 已经不送给 cmd2了，FD2 默认也不送过来，所以cmd2 也没有stdin ，所以在第二对括号里面：cmd1和cmd2 的stdout、stderr 为默认输出，一直遇到 “3&gt;&amp;1”为止。请注意：“3&gt;&amp;1”，先将第二对括号看出一个命令，他们遇到 第二个管道时，其FD1 连到 管道 “|”，由于“3&gt;&amp;1”的作用，子shell的FD1 送给FD3 使用，所以所有FD3 的输出都 “流往”cmd3，又由于继承关系（继承第一行的命令），FD3实际上就是cmd1和cmd2的stdout，于是“ cmd1 和 cmd2 的 stdout 定向到 cmd3 的 stdin” </p>
<p>第三对括号：(((cmd1 1&gt;&amp;3 ; echo $? &gt;&amp;4 )| cmd2 ) 3&gt;&amp;1 | cmd3 &gt;a 2&gt;&amp;3 ) 2&gt;&amp;1 和其后的第三个管道。<br />cmd1 和 cmd2 的 stdout 已经定向到 cmd3 的 stdin，处理之后，cmd3 &gt;a 意味着将其 stdout 送给 a 文件。而2&gt;&amp;3的意思是：恢复cmd3的错误输出为FD3，即送往 monitor。<br />于是“cmd3 的 stdout 定向到文件 a, stderr 定向到屏幕”。如果没有“2&gt;&amp;3”，那么cmd3的错误输出就会干扰cmd1和cmd2的错误输出，所以它是必须的！请注意第三对括号后 的 “2&gt;&amp;1”| ，其子shell的FD1 本来连接着管道“|”，但子shell FD1 慷慨大方，送给了 FD2，于是FD2 连接着管道。<br />还记得前面的 cmd1 和 cmd2 吗？他们的stderr一直没动了。于是在这里，通过管道送给了 第四个命令cmd4 了。即“cmd1 和 cmd2 的 stderr 定向到 cmd4 的 stdin”。<br />后面就比较简单了。cmd4 &gt;b 表示“cmd4 的 stdout 定向到文件 b, stderr 定向到屏幕（默认）” </p>
<p>第四对括 号：((((cmd1 1&gt;&amp;3 ; echo $? &gt;&amp;4 )| cmd2 ) 3&gt;&amp;1 | cmd3 &gt;a 2&gt;&amp;3 ) 2&gt;&amp;1 | cmd4 &gt;b ) 与其后的 4&gt;&amp;1。<br />四对括号里面的 FD1、FD2都处理完了。但是还记得前面“echo $? &gt;&amp;4”那块“草稿纸”吗？“4&gt;&amp;1”的作用就是“将草稿纸上的内容送给monitor”，但是由于最外面还有 $() 将其“包着”。<br />于是其值赋给变量“s”。</p>
<p> </p>
<p>转载至：http://www.xxlinux.com/linux/article/development/shell/2006-10-16/5018_2.html</p>
<p>http://www.cnblogs.com/huangzhen/archive/2011/08/21/2147834.html</p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 23:28:28</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/shell/" title="shell">shell</a>, <a href="https://www.iamivan.net/tag/file/" title="file">file</a>, <a href="https://www.iamivan.net/tag/linux/" title="linux">linux</a>, <a href="https://www.iamivan.net/tag/cmd/" title="cmd">cmd</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Linux shell中的I/O重定向相关（转）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPNvlZb.html" rel="bookmark">一些Linux Shell中的权限相关知识总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了一些Linux Shell中的权限相关知识总结,使Linux入门学习中的基础知识,需要的朋友可以参考下 一个文件一经创建,就具有三种访问方式: 1) 读,可以显示该文件的内容. 2) 写,可以编辑或删除它. 3) 执行,如果该文件是一个s h e l l脚本或程序. 按照所针对的用户,文件的权限可分为三类: 1) 文件属主,创建该文件的用户. 2) 同组用户,拥有该文件的用户组中的任何用户. 3) 其他用户,即不属于拥有该文件的用户组的某一用户 文件的全部信息包括以下: 文			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze0oPVp.html" rel="bookmark">linux shell 中 2＞&amp;amp&semi;amp&semi;1的含义&lowbar;linux shell</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				linux shell 中&quot;2&gt;&amp;1&quot;的含义 脚本: nohup /mnt/Nand3/H2000G  &gt;/dev/null  2&gt;&amp;1  &amp; 对于&amp; 1 更准确的说应该是文件描述符 1,而1 一般代表的就是STDOUT_FILENO,实际上这个操作就是一个dup2(2)调用.他标准输出到all_result ,然后复制标准输出到文件描述符2(STDERR_FILENO),其后果就是文件描述符1和2指向同一个文件表项,也可以说错误的输出			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP2k6Zb.html" rel="bookmark">Linux shell中的竖线（&vert;）&mdash;&mdash;&hellip;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址:Linux shell中的竖线(|)--管道符号作者:潇潇 管道符号,是unix一个很强大的功能,符号为一条竖线:&quot;|&quot;. 用法: command 1 | command 2 他的功能是把第一个命令command 1执行的结果作为command 2的输入传给command 2,例如: $ls -s|sort -nr (请注意不要复制$符号进去哦) -s 是file size,-n是numeric-sort,-r是reverse,反转 该命令列出当前目录中的文档(含size),			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ4B84M.html" rel="bookmark">&lbrack;转载&rsqb;Linux&nbsp;shell中的竖线（&vert;）&mdash;&mdash;管道符号</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址:Linux shell中的竖线(|)--管道符号作者:潇潇 管道符号,是unix一个很强大的功能,符号为一条竖线:&quot;|&quot;. 用法: command 1 | command 2 他的功能是把第一个命令command 1执行的结果作为command 2的输入传给command 2,例如: $ls -s|sort -nr (请注意不要复制$符号进去哦) -s 是file size,-n是numeric-sort,-r是reverse,反转 该命令列出当前目录中的文档(含size),			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPXEJ1p.html" rel="bookmark">一些Linux Shell中的权限相关知识总结&lowbar;linux shell</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一个文件一经创建,就具有三种访问方式: 1) 读,可以显示该文件的内容. 2) 写,可以编辑或删除它. 3) 执行,如果该文件是一个s h e l l脚本或程序. 按照所针对的用户,文件的权限可分为三类: 1) 文件属主,创建该文件的用户. 2) 同组用户,拥有该文件的用户组中的任何用户. 3) 其他用户,即不属于拥有该文件的用户组的某一用户 文件的全部信息包括以下: 文件的位置. 文件类型. 文件长度. 哪位用户拥有该文件,哪些用户可以访问该文件. 节点. 文件的修改时间. 文件的权限位. 可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/badR5gz.html" rel="bookmark">linux shell中的单引号与双引号的区别&lpar;看完就不会有引号的疑问了&rpar;&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				tips: ============================= IFS - LINUX字段分隔符,内部字段分隔符 IFS(Internal Field Seperator)在Linux的shell中预设的分隔符,用来把command line分解成word(字段). IFS可以是White Space(空白键).Tab( 表格键).Enter( 回车键)中的一个或几个. IFS是shell脚本中的一个重要概念,在处理文本数据时,它是相当有用的.内部字段分隔符是用于特定用途的定界符.IFS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zenrQVb.html" rel="bookmark">Linux Shell中的特殊符号和含义简明总结（包含了绝大部份）&lowbar;linux shell</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Linux Shell中有很多的特殊符号,这对于我们写Shell脚本时要特别留意:一方面要知道这些特殊符号的用法,这些符号用好了可以达到事半功倍的效果:但另一方面要避免这些特殊符号的过度使用而导致脚本难以调试.难以阅读. 这些特殊符号罗列出来大致如下: 复制代码 代码如下: # ; ;; . , / / 'string'| ! $ ${} $? $$ $* &quot;string&quot;* ** ? : ^ $# $@ `command`{} [] [[]] () (()) || &amp;&am			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7YggdM.html" rel="bookmark">linux shell中获取mongodb最大连接数、内存使用情况等</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前两天接到了一个新的需求,需要在linux shell脚本中监控到mongodb最大连接数.内存使用情况等. 但是我对于linux shel很不了解,只是会一些简单常用的linux的操作而已,只要一顿狂搜,最终多番尝试下终于获取到这些值. 成功的步骤大致如下: 0. ./mongostat -u admin -p admin --authenticationDatabase admin -n 1 --json &gt;&gt; aaa.txt 把mongodb监控到的一行数据以json格式写入到aaa.t			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjw88ZM.html" rel="bookmark">Linux shell中比较操作符&OpenCurlyDoubleQuote;&equals;&equals;&rdquo;与&OpenCurlyDoubleQuote;-eq&rdquo;对比</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://dgd2010.blog.51cto.com/1539422/1542048 在Linux shell编程中,经常会用到判断字符串是否相等,可用于判断字符串是否相等的操作符有'-eq'(相等), '-ne'(不等于), '-lt'(小于), '-le'(小于或等于), '-gt'(大于)或'-ge'(大于或等于),以及=,==,!=,&lt;,&gt;. 在bash指南中,字母操作符和符号			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91BKVM.html" rel="bookmark" class="title">tplink路由器怎么限制上网</a>
					<div>
						  tplink路由器限制上网的设置方法 准备动作,由于后面的操作在增加条目时需要用到MAC地址,所以我们先从DHCP服务器的客户端列表中获取客户端名 和 MAC地址 还可以从无线设置的主机状态中查看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPEo0z.html" rel="bookmark" class="title">cpu的正常温度是多少</a>
					<div>
						  cpu的正常温度是多少          cpu的正常温度 AMD处理器: AMD Althon, Althon Opteron, Duron 以及 Sempron 系列 AMD Athlon X ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlYyOb.html" rel="bookmark" class="title">利用 netsh winsock reset 命令修复网络应用错误</a>
					<div>
						  知识点分析: netsh 是从windows xp sp2开始提供的功能强大的网络配置命令行工具. 是一个能够通过命令行操作几乎所有网络相关设置的接口,比如设置IP,DNS,网卡,无线网络等. w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwqxap.html" rel="bookmark" class="title">PDF怎样转换成Word</a>
					<div>
						PDF格式良好的视觉阅读性和通用性使得PDF文件的使用越来越广泛了,网络上的PDF资料也越来越多,但是我们往往想要提出某些资料里面的部分文字内容进行二次编辑,那么我们这里就是讲比较通用的PDF转为WO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7KL7M.html" rel="bookmark" class="title">Photoshop调出女孩照片朦胧的逆光场景图</a>
					<div>
						  本教程主要使用Photoshop调出女孩照片朦胧的逆光场景图,素材图片也是在阳光下拍摄,不过人物部分有点逆光,画面的局部有点过曝.这些都需要慢慢修复,然后再在图片的右上角或左上角增加橙黄色高光增强 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7QZDb.html" rel="bookmark" class="title">布道云计算，阿里云MVP已启航</a>
					<div>
						6月10日,在上海召开的阿里云云栖大会上,当阿里云总裁胡晓明宣传&quot;阿里云聆听平台正式发布, MVP计划启动&quot;,立刻就得到了参会者的热议.这是中国云计算厂商首次推出全球最有价值技术贡 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGA2JoM.html" rel="bookmark" class="title">jQuery实现ajax调用WCF服务的方法&lpar;附带demo下载&rpar;&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery实现ajax调用WCF服务的方法.分享给大家供大家参考,具体如下: 关于AJAX调用WCF服务分为跨域和不跨域两种方式,今天咱们先介绍下不跨域下的调用方法.DEMO是在VS2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bam4rPb.html" rel="bookmark" class="title">CYQ&period;Data 数据框架 V3&period;0 版本 开放源码下载有&lbrack;CYQ&period;Blog&lpar;秋色园QBlog&rpar; 完全开放所有源码&rsqb;</a>
					<div>
						本次开放源码,长话短说:   1:本次开放CYQ.Data数据框架 V3.0版本,包含QBlog强大的XmlHelper源码,相关更新记录在底部. 2:CYQ.Blog(秋色园QBlog) 重新开放免 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2VXjb.html" rel="bookmark" class="title">eclipse-Android写的项目无法在模拟器上运行，错误在下面，怎么解决</a>
					<div>
						问题描述 Android写的项目无法在模拟器上运行,错误在下面,怎么解决 错误是:No content provider found for permission revoke: file:///da ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7Rgvz.html" rel="bookmark" class="title">&lbrack;华为机试真题&rsqb;67&period;奇偶数入座</a>
					<div>
						题目 代码 /*--------------------------------------- * 日期:2015-07-07 * 作者:SJF0115 * 题目:奇偶数入座 * 来源:华为机试真题  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QrgJp.html" rel="bookmark" class="title">请教多线程和多台服务器交互问题</a>
					<div>
						问题描述 有两台服务器A和B,主要业务逻辑在A,B为A提供一些基础服务受到底层框架的限制,A将所有client消息投递给一个线程,再分配给多个workerthread,而A与B的通信由一个独立的线程( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0oJnM.html" rel="bookmark" class="title">c&num;treeview怎么判断复选框是否有选中，有选中就修改，没有就返回，要怎么判断？</a>
					<div>
						问题描述 c#treeview怎么判断复选框是否有选中,有选中就修改,没有就返回,要怎么判断? 不管父节点和子节点只要有勾选就可以进修改! 解决方案 递归判断 bool isChecked(TreeN ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AOBPz.html" rel="bookmark" class="title">【Android开发】图形图像处理技术-绘制图片</a>
					<div>
						在Android中,Canvas类不仅可以绘制几何图形.文件和路径,还可以用来绘制图片.想要使用Canvas类绘制图片,只需要使用Canvas类提供的如下表所示的方法将Bitmap对象中保存的图片绘制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22mBrb.html" rel="bookmark" class="title">网络环保 你的网站开始行动了吗</a>
					<div>
						6月1日起全国限制使用塑料购物袋,这一环保的举动!引起了众多http://www.aliyun.com/zixun/aggregation/12181.html&quot;&gt;商家和消费者的支持! ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5okZp.html" rel="bookmark" class="title">RwriteUrl碰到的一个问题</a>
					<div>
						问题描述 在重写url的时候碰到这样一个问题,要把原来URL:http://a.com.cn/personl.aspx?username=xxx重写成http://a.com.cn/xxx,xxx可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JGxWz.html" rel="bookmark" class="title">iOS 环信APNS在开发阶段能收到，上线之后收不到</a>
					<div>
						问题描述 如题,已经确定开发阶段和上线阶段绑定的证书名称没问题,证书也是刚刚又重新生成的.但是总是开发调试的时候能收到,上线应用收不到. 解决方案 一.确认下是直接进入后台收不到消息还是程序kill掉 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW77XqM.html" rel="bookmark" class="title">SQL注入漏洞全接触&mdash;&mdash;入门篇&lowbar;Mssql系列教程</a>
					<div>
						随着B/S模式应用开发的发展,使用这种模式编写应用程序的程序员也越来越多.但是由于这个行业的入门门槛不高,程序员的水平及经验也参差不齐,相当大一部分程序员在编写代码的时候,没有对用户输入数据的合法性进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8950p.html" rel="bookmark" class="title">php中引用&amp;amp&semi;的用法分析【变量引用&comma;函数引用&comma;对象引用】&lowbar;php技巧</a>
					<div>
						本文实例分析了php中引用&amp;的用法.分享给大家供大家参考,具体如下: php的引用(就是在变量或者函数.对象等前面加上&amp;符号) //最重要就是 删除引用的变量 ,只是引用的变量访问不了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1yV8b.html" rel="bookmark" class="title">android有蓝牙打印图片代码谁有</a>
					<div>
						问题描述 今天做蓝牙打印,需要打印一个logo,我下载的demo运行打印出现乱码,谁有打印图片代码请贴出来,谢谢 解决方案 解决方案二:同求,我现在也在做这个,做好了交流一下啊,我的想法是把之前打印文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenrJVb.html" rel="bookmark" class="title">纽约时报：时尚界的网络迷局</a>
					<div>
						巴宝莉网站发布的俊男靓女身着风衣的街拍照片 导读:美国&lt;纽约时报&gt;网络版今天撰文称,虽然时尚界在现实生活中指引着全球的时尚潮流,但在网络世界中,这些时尚巨头却越来越跟不上潮流了. 以下为文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPvK1p.html" rel="bookmark" class="title">雅虎推&OpenCurlyDoubleQuote;贡献者网络&rdquo;突出用户制作内容</a>
					<div>
						北京时间11月15日晚间消息,据国外媒体报道,雅虎今天宣布推出&quot;雅虎贡献者网络(Yahoo! Contributor Network)&quot;平台,邀请用户为雅虎旗下的多个网站提供内容. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOWelqz.html" rel="bookmark" class="title">Google&colon;英国脱欧关我什么事，伦敦新总部建成才是事</a>
					<div>
						英国脱欧公投结束后,各界一直担忧是否会造成企业外移的问题,不过在周二(15日),Google 宣布,将原本延迟的英国新总部计划重启,会在英国伦敦打造一个 10 层楼的新总部,可容纳 7000 位员工, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8GqJxM.html" rel="bookmark" class="title">八省区列为电力现货市场试点 打通风电光伏发电进场通道</a>
					<div>
						9月5日,&lt;证券日报&gt;记者获悉,为加快建设完善电力市场体系,国家发改委办公厅和国家能源局综合司联合印发&lt;关于开展电力现货市场建设试点工作的通知&gt;(以下简称&lt;通知&gt;) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrv67vM.html" rel="bookmark" class="title">雅虎有可能与新闻集团合并</a>
					<div>
						北京时间11月13日上午消息,据国外媒体今日报道,消息人士透露,与最近沸沸扬扬的雅虎与AOL合并案相比,雅虎更有可能与新闻集团合并. 雅虎最近刚刚聘请罗斯·莱文索恩(RossLevinsohn)出任执 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Y1mDp.html" rel="bookmark" class="title">SmartX成为唯一同时进入两份市场报告的中国超融合产品厂商</a>
					<div>
						近日,IDC在新发布的&lt;2017Q1 China SDS and HCI Market Overview&gt;报告中分别从2017年Q1关键供应商市场份额.垂直市场分布.市场收入增长比例等角度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAQVdAM.html" rel="bookmark" class="title">SQL2005问题</a>
					<div>
						问题描述 SQLServer已经暂停.不允许进行新的连接.用户'sa'登录失败.说明:执行当前Web请求期间,出现未处理的异常.请检查堆栈跟踪信息,以了解有关该错误以及代码中导致错误的出处的详细信息. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDj5eWM.html" rel="bookmark" class="title">不论是估值还是企业决策，要进行有依据的合理推理</a>
					<div>
						我们不论是估值还是企业决策,在实战运营中都必须要有统计学的观念和概率的思想,要进行有依据的合理推理.比如Dr.2的合伙人曾经对别人说过:我是他见过的医生里面经济学和财务知识最多的人.那么由此可以大致推 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWKv0GM.html" rel="bookmark" class="title">索尼PlayStation 4真人广告流出 美式枪车球主导</a>
					<div>
						[TechWeb报道]对于下个月即将正式发售的 索尼PS4来说,造势工作已经轰轰烈烈的展开了.今日,索尼公司正式对外发布了首款PlayStation 4的电视广告.出人意料的是,此条索尼PS4广告并未 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZRj75z.html" rel="bookmark" class="title">刚入门应该怎么办啊。</a>
					<div>
						问题描述 打扰了,我是刚毕业的学生,学的java.可是要被分到做vb.net的部门了,我对这个一点概念都没有,应该怎么办啊, 解决方案 解决方案二:求助自己的同事是最好的,还有最好的有同事收你为徒.解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBG39oM.html" rel="bookmark" class="title">徒手掰弯iPhone 6 Plus？你能！</a>
					<div>
						摘要: 今天盛传 iPhone 6 Plus 放在口袋后几天后竟然发现手机变形了. 有用户表示,自己揣着 iPhone 6 Plus 只进行了 2-3 个小时跳舞,开车 4 个小时去参加婚礼,手机在口 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
